=== debian/changelog ===
hatari (2.5.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.0+dfsg
  * Update copyright authors and years
  * Update my copyright years
  * Revert "Add patch fixing a groff warning in hatari_profile.1"
  * Add Build-Depends on libcapstone-dev for a new disassembler
  * Drop copyright stanza for removed cmake snippet
  * Bump Standards-Version to 4.7.0 (No changes needed)
  * Refresh patch 13-python-ui-doc-paths

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 10 Dec 2024 21:30:20 +0200
