=== debian/watch ===
version=4
        opts=dversionmangle=s/\+dfsg\d//,uversionmangle=s/(.*)/$1+dfsg/ \
        https://download.tuxfamily.org/hatari/(\d\.\d\.\d)/hatari-(.*).tar.bz2
