## hatari 2.6.1+dfsg

=== debian/changelog ===
hatari (2.6.1+dfsg-2) unstable; urgency=medium

  * Drop Priority: optional
  * Upgrade Standards-Version to 4.7.3.
  * Split binfmt support into a separate package, hatari-binfmt
  * Update my copyright years

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 08 Feb 2026 21:50:12 +0200

hatari (2.6.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.6.1+dfsg
  * Add debian/gbp.conf with debian branch name
  * Bump Standards-Version to 4.7.2, no changes needed
  * Drop Rules-Requires-Root: no, no longer needed
  * Drop patch updating URLs to new upstream home, no longer needed
  * Refresh patch python-ui-doc-paths
  * Update debian/watch to version 5 syntax
  * Add debian/sharedmimeinfo symlink to upstream mimeinfo file
  * Drop explicit python dependencies, rely just on ${python3:Depends}
  * Run wrap-and-sort -ast
  * Add relevant documentation in doc/ to debian/docs
  * Add doc/toc.js to debian/docs, the html documentation uses it
  * Add copyright information for doc/toc.js
  * Add hconsole documentation to debian/docs
  * Update copyright information for 2.6.1
  * Update my copyright years

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 25 Nov 2025 18:57:37 +0200

hatari (2.5.0+dfsg-2) unstable; urgency=medium

  * Add patch from upstrem updating URLs to new home of Hatari
  * Update upstream URLs in debian/copyright and debian/control

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Wed, 14 May 2025 14:58:43 +0300
