=== debian/control ===
Source: hatari
Section: otherosfs
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 cmake,
 libcapstone-dev,
 libpng-dev,
 libreadline-dev,
 libsdl2-dev,
 python3,
 zlib1g-dev,
Standards-Version: 4.7.3
Homepage: http://www.hatari-emu.org/

Package: hatari
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 dosfstools,
 mtools,
 unzip,
 hatari-binfmt,
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 Unlike most other open source Atari ST emulators which try to provide a good
 environment for running GEM applications, Hatari tries to emulate the hardware
 of a ST as close as possible so that it is able to run most of the old Atari
 games and demos. Because of this, it may be somewhat slower than less accurate
 emulators.

Package: hatari-binfmt
Architecture: all
Depends:
 hatari,
 systemd | binfmt-support,
 ${misc:Depends},
Description: Register hatari as the interpreter for Atari TOS executables
 Hatari is an emulator for the Atari ST line of computers (Atari ST,
 STE, TT, and Falcon).
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 This package provides binfmt registration for Atari ST executables.
