=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,9 @@
 override_dh_install:
 	dh_install
 
-	# Install binfmt support for atari binaries
-	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari
-	install -m644 -D debian/binfmt.conf debian/hatari/usr/lib/binfmt.d/hatari.conf
+	# Install binfmt support for Atari TOS binaries
+	install -m644 -D debian/binfmt debian/hatari-binfmt/usr/share/binfmts/hatari
+	install -m644 -D debian/binfmt.conf debian/hatari-binfmt/usr/lib/binfmt.d/hatari.conf
 
 override_dh_auto_test:
 	true
